<?php

class bProduit_export extends BackModule {

    public function __construct($formvars = array())
    {
        parent::__construct($formvars);
        $GLOBALS['displayMcFileManager'] = true;
    }

    // Export le catalogue
    function export_catalogue($formvars = array()) {

        $arrParam = array();
        if (!empty($formvars['pc*categorie_id'])) {
            $arrParam['categorie_id'] = $formvars['pc*categorie_id'];
        }
        if (!empty($formvars['p*produit_statut_id'])) {
            $arrParam['produit_statut_list'] = implode($formvars['p*produit_statut_id'], ',');
        }
        if (!empty($formvars['p*marque_id'])) {
            $arrParam['marque_id'] = $formvars['p*marque_id'];
        }
        if (!empty($formvars['p*fournisseur_id'])) {
            $arrParam['fournisseur_id'] = $formvars['p*fournisseur_id'];
        }
        if (!empty($formvars['p*produit_signalement_id'])) {
            $arrParam['produit_signalement_id'] = $formvars['p*produit_signalement_id'];
        }

        $catalogue = new Catalogue;
        $catalogue->export($arrParam);
    }

    // import catalogue
    function import_catalogue($formvars = array()) {

        if (!$this->droits['EXP']) {
            $out = "ERROR 154 !!";
            return $out;
            exit;
        }

        if (@$_GET['submitBTN'] == 'cmd_import') {
            //var_dump($formvars);exit;
            // nom du fichier Excel
            // $arrParam['filename'] = 'import_20100615.xls';
            $arrParam['filename'] = str_replace(SITE_URL,SITE_DIR,$formvars['file_import']);

            // liste des feuilles à parcourir
            $arrParam['sheets'] = array('Catalogue');

            // numéro de la ligne a laquelle commence les données à inserer, pour eviter les lignes d'entete
            $arrParam['startData'] = 2;

            $catalogue = new Catalogue;
            $catalogue->import($arrParam);

            echo '<style>.recap td {text-align:left;}</style>
                <table class="records recap">
		    <thead>
		      <tr>
		        <th colspan="2" style="text-align:left;">R&eacute;capitulatif : </th>
		      </tr>
		    </thead>
		    <tbody>
		      <tr class="resultr highlight">
		        <td>
                        Produits :
                        </td>
                        <td>'.$catalogue->produit['creation'].' produit(s) cr&eacute;e.</td>
                      </tr>
                      <tr class="resultr highlight">
		        <td>
                       &nbsp;
                        </td>
                        <td>'.$catalogue->produit['modif'].' produit(s) modifi&eacute;s.</td>
                      </tr>
                      <tr class="resultr highlight">
		        <td>
                       &nbsp;
                        </td>
                        <td>'.$catalogue->produit['archive'].' produit(s) archiv&eacute;s.</td>
                      </tr>

                      <tr class="resultr highlight">
		        <td>
                        Attributs :
                        </td>
                        <td>'.$catalogue->attribut['creation'].' attribut(s) cr&eacute;e.</td>
                      </tr>
                      <tr class="resultr highlight">
		        <td>
                       &nbsp;
                        </td>
                        <td>'.$catalogue->attribut['modif'].' attribut(s) modifi&eacute;s.</td>
                      </tr>
                      <tr class="resultr highlight">
		        <td>
                       &nbsp;
                        </td>
                        <td>'.$catalogue->attribut['archive'].' attribut(s) archiv&eacute;s.</td>
                      </tr>
                      <tr class="resultr">
		        <td colspan="2">';
                    if(!empty($catalogue->error)) {
                    foreach($catalogue->error as $err){
                        echo '<div>Ligne : '.$err['ligne'].' - '.$err['commentaire'].'</div>';
                      }
                    }else{
                     echo 'Aucune erreur';
                    }
                        echo '</td>
                      </tr>
                    </tbody>
                  </table>';

        }else{

        echo '
		<form name="miniForm" method="post" action="/back/html/produit/export/import_catalogue/" onsubmit="checkForm(this,1);flo();return false;">
		  <input type="hidden" value="" name="submitBTN"/>
		  <table class="records">
		    <thead>
		      <tr>
		        <th></th>
		      </tr>
		    </thead>
		    <tbody>
		      <tr class="resultr highlight" id="boutique_line_19">
		        <td class="">
		        <p>
                          <label>Fichier Catalogue &agrave; Jour</label>
                          
                          <input type="button" onclick="javascript:mcFileManager.open(\'miniForm\',\'file_import\',\'\',\'\',{});" value="Parcourir" class="fileBTN"/>
                          <input type="text" size="20" class="required" style="width: 50%;" title="Le champ est requis" value="" name="file_import"/>
                        </p>

		        </td>
		      </tr>
		    </tbody>
		  </table>
		  <table class="records">
		    <tbody>
		      <tr>
		        <td><input type="submit" value="VALIDER" name="cmd_import" onclick="document.miniForm.submitBTN.value=this.name;" style="width: 100%;"/></td>
		      </tr>
		    </tbody>
		  </table>
		</form>
		';
        }
    }

}