﻿<?php

class bTableau_bord extends BackModule {

    var $dataGraph;
    // donn�es pour le graph
    var $itemGraph = array();
    // donn�es pour le graph
    var $formvars;
    // donn�es de recherce
    var $sessionName; // objet en session

    function __construct($formvars = array())
    {
        parent::__construct($formvars);

        $this->droits['MOD'] = false;
    }

    function Listing($formvars = array()) {

        if (!$this->droits['READ']) {
            header('Location: /back/');
            exit;
            //exit;
        }
        $out = "";

        $out .= '
        <section class="content-header">
            <h1>Tableau de bord</h1>
            <ol class="breadcrumb">
                <li><a href="/back/"><i class="fa fa-dashboard"></i> Home</a></li>
                <li><a href="/back/html/tableau_bord/list/">Tableau de bord</a></li>
            </ol>
        </section>
        ';

        $out .= "<div class='content'>";

        $out .= "<div class='row'>";

        // --REQUETE NB COMMANDE
        //aujourd'hui
        $sql = "SELECT COUNT(commande_id) as nb_commande";
        $sql.=" FROM commande";
        $sql.=" WHERE DATE(commande_date_ajout) = CURRENT_DATE()";
        $sql.=" AND commande_statut_id != 99";

        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $aujourdhui = $this->sql->record[0];

        $out .= "<div class='col-md-3 col-sm-6 col-xs-12'>";
        $out.= '
            
            <div class="small-box bg-aqua">
                <div class="inner">
                  <h3>'.$aujourdhui['nb_commande'].'</h3>
                  <p>Commandes</p>
                </div>
                <div class="icon">
                  <i class="fa fa-credit-card"></i>
                </div>
            </div>
        ';
        $out.='</div>';


        // -- Bloc recapitulatif
        // --REQUETE CA
        //aujourd'hui
        $sql = "SELECT ROUND(SUM(commande_total_ht),2) as ca";
        $sql.=" FROM commande";
        $sql.=" WHERE DATE(commande_date_ajout) = CURRENT_DATE()";
        $sql.=" AND commande_statut_id != 99";

        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $aujourdhui = $this->sql->record[0];

        $out .= "<div class='col-md-3 col-sm-6 col-xs-12'>";
        $out.= '
            <div class="small-box bg-green">
                <div class="inner">
                  <h3>'.(float) $aujourdhui['ca'].' EUR</h3>
                  <p>CA HT</p>
                </div>
                <div class="icon">
                  <i class="fa fa-line-chart"></i>
                </div>
            </div>
        ';
        $out.='</div>';

        // -- Bloc recapitulatif
        // --REQUETE PANIER MOYEN
        //aujourd'hui
        $sql = "SELECT ROUND(SUM(commande_stotal_ht)/COUNT(commande_id),2) as pm";
        $sql.=" FROM commande c";
        $sql.=" WHERE DATE(commande_date_ajout) = CURRENT_DATE()";
        $sql.=" AND commande_statut_id != 99";

        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $aujourdhui = $this->sql->record[0];

        $out .= "<div class='col-md-3 col-sm-6 col-xs-12'>";
        $out.= '
            <div class="small-box bg-red">
            <div class="inner">
              <h3>'.(float) $aujourdhui['pm'].' EUR</h3>
              <p>Panier Moyen</p>
            </div>
            <div class="icon">
              <i class="fa fa-shopping-cart"></i>
            </div>
            </div>
        ';
        $out.='</div>';

        // -- Bloc recapitulatif
        // --REQUETE NOUVEAUX CLIENTS
        //aujourd'hui
        $sql = "SELECT COUNT(client_id) as nb_client";
        $sql.=" FROM client";
        $sql.=" WHERE DATE(client_date_ajout) = CURRENT_DATE()";
        $sql.=" AND client_statut_id = 1";

        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $aujourdhui = $this->sql->record[0];

        $out .= "<div class='col-md-3 col-sm-6 col-xs-12'>";
        $out.= '
            <div class="small-box bg-yellow">
            <div class="inner">
              <h3>'.$aujourdhui['nb_client'].'</h3>
              <p>Nouveaux clients</p>
            </div>
            <div class="icon">
              <i class="fa fa-users"></i>
            </div>
            </div>
        ';
        $out.='</div>';

        // -- Bloc recapitulatif

        $out .= "</div>";       // fin .row

        // -- Colonne de gauche
        // Contenue de droite --
        // Formulaire --

        $out.="<div class='row'>";
        $out.="<div class='col-md-4'>";
        $out .= "<form id='form1' action='/back/html/tableau_bord/list/' name='form1' method='get' class='form-horizontal'>";
        $out .= "<div class='box box-solid box-primary'>";
        $out.='<div class="box-header with-border"><h3 class="box-title">Recherche</h3></div>
		      <div class="box-body">';


        // Un champ de recherche (avec select) --
        $out .= "<div class='form-group'>";
        $out .= "<label class='control-label col-sm-2'>";
        $out .= "Par";
        $out .= "</label>";

        // valeur par defaut
        if (!isset($_GET['group']))
            $_GET['group'] = 'day';

        $out.='<div class="col-sm-10">';
        $out .= "<select name='group' class='form-control'>";
        if ($_GET["group"] == 'day') {
            $out .= "<option selected='selected' value='day'>Jour</option>";
        } else {
            $out .= "<option value='day'>Jour</option>";
        }
        if ($_GET["group"] == 'week') {
            $out .= "<option selected='selected' value='week'>Semaine</option>";
        } else {
            $out .= "<option value='week'>Semaine</option>";
        }
        if ($_GET["group"] == 'month') {
            $out .= "<option selected='selected' value='month'>Mois</option>";
        } else {
            $out .= "<option value='month'>Mois</option>";
        }
        if ($_GET["group"] == 'quarter') {
            $out .= "<option selected='selected' value='quarter'>Trimestre</option>";
        } else {
            $out .= "<option value='quarter'>Trimestre</option>";
        }
        if ($_GET["group"] == 'year') {
            $out .= "<option selected='selected' value='year'>Année</option>";
        } else {
            $out .= "<option value='year'>Année</option>";
        }
        if ($_GET["group"] == 'produit') {
            $out .= "<option selected='selected' value='produit'>Produit</option>";
        } else {
            $out .= "<option value='produit'>Produit</option>";
        }
        if ($_GET["group"] == 'produit_attribut') {
            $out .= "<option selected='selected' value='produit_attribut'>Produit attribut</option>";
        } else {
            $out .= "<option value='produit_attribut'>Produit attribut</option>";
        }
        $out .= "</select>";
        $out .= "</div>";
        $out .= "</div>";


        // -- Un champ de recherche (avec select)
        // Un champ de recherche (avec select) --
        $out .= "<div class='form-group'>";
        $out .= "<label class='control-label col-sm-2'>";
        $out .= "Date";
        $out .= "</label>";

        // valeur par defaut
        if (!isset($_GET['select_date']))
            $_GET['select_date'] = 'cmd';

        $out.='<div class="col-sm-10">';
        $out .= "<select name='select_date' class='form-control'>";
        if ($_GET["select_date"] == 'cmd') {
            $out .= "<option selected='selected' value='cmd'>Date de commande</option>";
        } else {
            $out .= "<option value='cmd'>Date de commande</option>";
        }
        if ($_GET["select_date"] == 'fact') {
            $out .= "<option selected='selected' value='fact'>Date de facturation</option>";
        } else {
            $out .= "<option value='fact'>Date de facturation</option>";
        }
        $out .= "</select>";
        $out .= "</div>";
        $out .= "</div>";

        if (!isset($_GET["date"][0])) {
            $date_debut = date('d/m/Y', time() - 30 * 24 * 3600);
        } else {
            $date_debut = $_GET["date"][0];
        }

        if (!isset($_GET["date"][1])) {
            $date_fin = date('d/m/Y');
        } else {
            $date_fin = $_GET["date"][1];
        }

        $dateRange = $date_debut . ' - ' . $date_fin;

        $out.='
            <!-- Date and time range -->
              <div class="form-group">
                <input type="hidden" name="date[]" id="date_debut" value="'.$date_debut.'" />
                <input type="hidden" name="date[]" id="date_fin" value="'.$date_fin.'" />
                <label class="control-label col-sm-2">Periode</label>

                <div class="col-sm-10">
                  <button type="button" class="col-sm-12 btn btn-default" id="daterange-btn">
                    <span>
                      <i class="fa fa-calendar"></i> '.$dateRange.'
                    </span>
                    <i class="fa fa-caret-down"></i>
                  </button>
                </div>
              </div>
              <!-- /.form group -->
        ';

        $out.="
        <script>
        //Date range as a button
            jQuery(document).ready(function(){
                jQuery('#daterange-btn').daterangepicker(
                  {
                    ranges   : {
                      'Aujourd\'hui'       : [moment(), moment()],
                      'Hier'   : [moment().subtract(1, 'days'), moment().subtract(1, 'days')],
                      '7 jours' : [moment().subtract(6, 'days'), moment()],
                      '30 jours': [moment().subtract(29, 'days'), moment()],
                      'Mois en cours'  : [moment().startOf('month'), moment().endOf('month')],
                      'Dernier mois'  : [moment().subtract(1, 'month').startOf('month'), moment().subtract(1, 'month').endOf('month')]
                    },
                    startDate: moment().subtract(29, 'days'),
                    endDate  : moment(),
                    autoApply: true,
                    locale: {
                        'format': 'DD/MM/YYYY',
                        'separator': ' - ',
                        'applyLabel': 'Valider',
                        'cancelLabel': 'Annuler',
                        'fromLabel': 'Du',
                        'toLabel': 'Au',
                        'customRangeLabel': 'Selectionner',
                        'weekLabel': 'W',
                        'daysOfWeek': [
                            'Di',
                            'Lu',
                            'Ma',
                            'Me',
                            'Je',
                            'Ve',
                            'Sa'
                        ],
                        'monthNames': [
                            'Janvier',
                            'Février',
                            'Mars',
                            'Avril',
                            'Mai',
                            'Juin',
                            'Juillet',
                            'Août',
                            'Septembre',
                            'Octobre',
                            'Novembre',
                            'Décembre'
                        ],
                        'firstDay': 1
                    }
                  },
                  function (start, end) {
                    jQuery('#daterange-btn span').html(start.format('DD/MM/YYYY') + ' - ' + end.format('DD/MM/YYYY'))
                    jQuery('#date_debut').val(start.format('DD/MM/YYYY'));
                    jQuery('#date_fin').val(end.format('DD/MM/YYYY'));
                  }
                );
            });
            </script>
        ";


        // -- Un champ de recherche (avec champ date)
        // Un champ de recherche (avec select) --
        $out .= "<div class='form-group'>";
        $out .= "<label class='control-label col-sm-2'>";
        $out .= "Avoir le";
        $out .= "</label>";
        $out .= "<div class='col-sm-10'>";

        // valeur par defaut
        if (!isset($_GET['item']) || ($_GET['item'][0] == 'nb_client' && $_GET['group'] == 'produit') || ($_GET['item'][0] == 'nb_client' && $_GET['group'] == 'produit_attribut'))
            $_GET['item'][0] = 'ca_ht';

        $out .= "<select name='item[]' class='form-control select2' multiple='multiple'>";
        if (isset($_GET["item"]) && in_array('ca_ht', $_GET["item"])) {
            $out .= "<option selected='selected' value='ca_ht'>Chiffre d'affaire HT</option>";
        } else {
            $out .= "<option value='ca_ht'>Chiffre d'affaire HT</option>";
        }
        if (isset($_GET["item"]) && in_array('ca_ttc', $_GET["item"])) {
            $out .= "<option selected='selected' value='ca_ttc'>Chiffre d'affaire TTC</option>";
        } else {
            $out .= "<option value='ca_ttc'>Chiffre d'affaire TTC</option>";
        }
        if (isset($_GET["item"]) && in_array('sca_ht', $_GET["item"])) {
            $out .= "<option selected='selected' value='sca_ht'>Chiffre d'affaire HT (hors frais de port)</option>";
        } else {
            $out .= "<option value='sca_ht'>Chiffre d'affaire HT (hors frais de port)</option>";
        }
        if (isset($_GET["item"]) && in_array('sca_ttc', $_GET["item"])) {
            $out .= "<option selected='selected' value='sca_ttc'>Chiffre d'affaire TTC (hors frais de port)</option>";
        } else {
            $out .= "<option value='sca_ttc'>Chiffre d'affaire TTC (hors frais de port)</option>";
        }
        if (isset($_GET["item"]) && in_array('fdp_ht', $_GET["item"])) {
            $out .= "<option selected='selected' value='fdp_ht'>Frais de port HT</option>";
        } else {
            $out .= "<option value='fdp_ht'>Frais de port HT</option>";
        }
        if (isset($_GET["item"]) && in_array('fdp_ttc', $_GET["item"])) {
            $out .= "<option selected='selected' value='fdp_ttc'>Frais de port TTC</option>";
        } else {
            $out .= "<option value='fdp_ttc'>Frais de port TTC</option>";
        }
        //En attente
        if (isset($_GET["item"]) && in_array('marge_ht', $_GET["item"])) {
            $out .= "<option selected='selected' value='marge_ht'>Marge HT</option>";
        } else {
            $out .= "<option value='marge_ht'>Marge HT</option>";
        }
        if (isset($_GET["item"]) && in_array('marge_ttc', $_GET["item"])) {
            $out .= "<option selected='selected' value='marge_ttc'>Marge TTC</option>";
        } else {
            $out .= "<option value='marge_ttc'>Marge TTC</option>";
        }
        if (isset($_GET["item"]) && in_array('nb_commande', $_GET["item"])) {
            $out .= "<option selected='selected' value='nb_commande'>Nombre de commandes</option>";
        } else {
            $out .= "<option value='nb_commande'>Nombre de commandes</option>";
        }
        if (isset($_GET["item"]) && in_array('nb_produit', $_GET["item"])) {
            $out .= "<option selected='selected' value='nb_produit'>Nombre de produits commandés</option>";
        } else {
            $out .= "<option value='nb_produit'>Nombre de produits commandés</option>";
        }
        if (isset($_GET["item"]) && in_array('promo_ht', $_GET["item"])) {
            $out .= "<option selected='selected' value='promo_ht'>Cout promo HT</option>";
        } else {
            $out .= "<option value='promo_ht'>Cout promo HT</option>";
        }
        if (isset($_GET["item"]) && in_array('promo_ttc', $_GET["item"])) {
            $out .= "<option selected='selected' value='promo_ttc'>Cout promo TTC</option>";
        } else {
            $out .= "<option value='promo_ttc'>Cout promo TTC</option>";
        }
        if (isset($_GET["item"]) && in_array('nb_promos', $_GET["item"])) {
            $out .= "<option selected='selected' value='nb_promos'>Nombres de promo utilisés</option>";
        } else {
            $out .= "<option value='nb_promos'>Nombres de promo utilisés</option>";
        }
        $out .= "</select>";
        $out .= "</div>";
        $out .= "</div>";
        // -- Un champ de recherche (avec select)

        // -- Force le passage à la ligne
        // Un champ de recherche (avec select) --
        $out .= "<div class='form-group'>";
        $out .= "<label class='control-label col-sm-2'>";
        $out .= "Catégories";
        $out .= "</label>";
        $out .= "<div class='col-sm-10'>";
        $out .= "<select name='categorie_id[]' class='form-control select2' multiple='multiple'>";
        $parent = "SELECT c.categorie_id, cn.categorie_nom_nom FROM (categorie c,categorie_nom cn) WHERE parent_id IS NULL AND cn.langue_id='" . LANGUE . "' AND c.categorie_id=cn.categorie_id ORDER BY categorie_nom_nom";
        $this->sql->query($parent, SQL_ALL, SQL_INDEX);
        $rows = $this->sql->record;
        foreach ($rows as $row) { //Liste les categorie parent
            if (isset($_GET["categorie_id"]) && in_array($row[0], $_GET["categorie_id"])) {
                $out .= "<option selected='selected' value='" . $row[0] . "'>" . $row[1] . "</option>";
            } else {
                $out .= "<option value='" . $row[0] . "'>" . $row[1] . "</option>";
            }
            $categorie = "SELECT c.categorie_id, cn.categorie_nom_nom FROM (categorie c,categorie_nom cn) WHERE cn.langue_id='" . LANGUE . "' AND c.categorie_id=cn.categorie_id AND c.parent_id = " . $row[0] . " ORDER BY categorie_nom_nom";
            $this->sql->query($categorie, SQL_ALL, SQL_INDEX);
            $rows2 = $this->sql->record;
            foreach ($rows2 as $row2) {//Liste les categorie enfant
                if (isset($_GET["categorie_id"]) && in_array($row2[0], $_GET["categorie_id"])) {
                    $out .= "<option selected='selected' value='" . $row2[0] . "'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" . $row2[1] . "</option>";
                } else {
                    $out .= "<option value='" . $row2[0] . "'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" . $row2[1] . "</option>";
                }
            }
        }
        $out .= "</select>";
        $out .= "</div>";
        $out .= "</div>";

        // -- Un champ de recherche (avec select)
        // Un champ de recherche (avec select) --
        $out .= "<div class='form-group'>";
        $out .= "<label class='control-label col-sm-2'>";
        $out .= "Gammes";
        $out .= "</label>";
        $out .= "<div class='col-sm-10'>";
        $out .= "<select name='gamme_id[]' class='form-control select2' multiple='multiple'>";
        $gamme = "SELECT c.gamme_id, cn.gamme_nom_nom FROM (gamme c,gamme_nom cn) WHERE cn.langue_id='" . LANGUE . "' AND c.gamme_id=cn.gamme_id ORDER BY gamme_nom_nom";
        $this->sql->query($gamme, SQL_ALL, SQL_INDEX);
        $rows = $this->sql->record;
        foreach ($rows as $row) {//Liste les gammes
            if (isset($_GET["gamme_id"]) && in_array($row[0], $_GET["gamme_id"])) {
                $out .= "<option selected='selected' value='" . $row[0] . "'>" . $row[1] . "</option>";
            } else {
                $out .= "<option value='" . $row[0] . "'>" . $row[1] . "</option>";
            }
        }
        $out .= "</select>";
        $out .= "</div>";
        $out .= "</div>";

        // -- Un champ de recherche (avec select)
        // Double champ de recherche (avec input text) --
        $out .= "<div class='form-group'>";
        $out .= "<label class='control-label col-sm-2'>";
        $out .= "Ref produit";
        $out .= "</label>";
        $out .= "<div class='col-sm-10'>";
        if (isset($_GET["produit_ref"])) {//Tri par reference produit du client
            $out .= "<input class='form-control' value='" . $_GET["produit_ref"] . "' name='produit_ref'/>";
        } else {
            $out .= "<input class='form-control' name='produit_ref' />";
        }

        $out .= "</div>";
        $out .= "</div>";

        $out .= "<div class='form-group'>";
        $out .= "<label class='control-label col-sm-2'>";
        $out .= "Ref Frs produit";
        $out .= "</label>";
        $out .= "<div class='col-sm-10'>";
        if (isset($_GET["produit_ref_frs"])) {//Tri par reference produit du fournisseur
            $out .= "<input class='form-control' value='" . $_GET["produit_ref_frs"] . "' name='produit_ref_frs'/>";
        } else {
            $out .= "<input class='form-control' name='produit_ref_frs'/>";
        }
        $out .= "</div>";
        $out .= "</div>";

        // -- Double champ de recherche (avec input text)
        // Un champ de recherche (avec select) --
        $out .= "<div class='form-group'>";
        $out .= "<label class='control-label col-sm-2'>";
        $out .= "Marques";
        $out .= "</label>";
        $out .= "<div class='col-sm-10'>";
        $out .= "<select name='marque_id[]' class='form-control select2' multiple='multiple'>";
        $marque = "SELECT m.marque_id, m.marque_nom FROM (marque m) ORDER BY marque_nom";
        $this->sql->query($marque, SQL_ALL, SQL_INDEX);
        $rows = $this->sql->record;
        foreach ($rows as $row) {//Liste les marques pour le tri
            if (isset($_GET["marque_id"]) && in_array($row[0], $_GET["marque_id"])) {
                $out .= "<option selected='selected' value='" . $row[0] . "'>" . $row[1] . "</option>";
            } else {
                $out .= "<option value='" . $row[0] . "'>" . $row[1] . "</option>";
            }
        }
        $out .= "</select>";
        $out .= "</div>";
        $out .= "</div>";

        // -- Un champ de recherche (avec select)
        // Un champ de recherche (avec select) --
        $out .= "<div class='form-group'>";
        $out .= "<label class='control-label col-sm-2'>";
        $out .= "Fournisseurs";
        $out .= "</label>";
        $out .= "<div class='col-sm-10'>";
        $out .= "<select name='fournisseur_id[]' class='form-control select2' multiple='multiple'>";
        $fournisseur = "SELECT f.fournisseur_id, f.fournisseur_nom FROM (fournisseur f) ORDER BY fournisseur_nom";
        $this->sql->query($fournisseur, SQL_ALL, SQL_INDEX);
        $rows = $this->sql->record;
        foreach ($rows as $row) {//Liste les fournisseurs pour le tri
            if (isset($_GET["fournisseur_id"]) && in_array($row[0], $_GET["fournisseur_id"])) {
                $out .= "<option selected='selected' value='" . $row[0] . "'>" . $row[1] . "</option>";
            } else {
                $out .= "<option value='" . $row[0] . "'>" . $row[1] . "</option>";
            }
        }
        $out .= "</select>";
        $out .= "</div>";
        $out .= "</div>";

        // -- Un champ de recherche (avec select)
        // Un champ de recherche (avec select) --
        $out .= "<div class='form-group'>";
        $out .= "<label class='control-label col-sm-2'>";
        $out .= "Paiement";
        $out .= "</label>";
        $out .= "<div class='col-sm-10'>";

        $out .= "<select name='paiement_id[]' class='form-control select2' multiple='multiple'>";
        $paiement = "SELECT p.paiement_id, pn.paiement_nom_nom FROM (paiement p) LEFT JOIN (paiement_nom pn) ON (p.paiement_id=pn.paiement_id)  ORDER BY pn.paiement_nom_nom";
        $this->sql->query($paiement, SQL_ALL, SQL_INDEX);
        $rows = $this->sql->record;
        foreach ($rows as $row) {//Liste les mode de paiement
            if (isset($_GET["paiement_id"]) && in_array($row[0], $_GET["paiement_id"])) {
                $out .= "<option selected='selected' value='" . $row[0] . "'>" . $row[1] . "</option>";
            } else {
                $out .= "<option value='" . $row[0] . "'>" . $row[1] . "</option>";
            }
        }
        $out .= "</select>";
        $out .= "</div>";
        $out .= "</div>";
        // -- Un champ de recherche (avec select)


        $out .= "</div>";

        $out .= "<div class='box-footer'>
                    <button type='submit' class='btn btn-primary pull-right'>Rechercher</button>
                </div>";



        $out .= "</div>";
        $out .="</form>";
        $out .= "</div>";




        // CAS DE LA RECHERCHE PAR categorie_id


        //-- RECHERCHE

        $searchSPEC = false;

        // CAS DE LA RECHERCHE PAR categorie_id
        if (!empty($_GET['categorie_id'][0])) {
            $searchProduit = array(-1);
            foreach($_GET['categorie_id'] as $zeCat) {
                $sql="SELECT produit_id FROM produit_categorie pc";
                $sql.=" LEFT JOIN categorie c ON (c.categorie_id = pc.categorie_id)";
                $sql.=" WHERE c.categorie_id = '".$zeCat."' OR c.parent_id = '".$zeCat."'";
                $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
                $arrProd = $this->sql->record;
                foreach($arrProd as $p) {
                    array_push($searchProduit,$p['produit_id']);
                }
                $searchProduit = array_unique($searchProduit);
            }
            $searchSPEC = true;
        }

        if (!empty($_GET['gamme_id'][0])) {
            $searchProduitGamme = array(-1);
            foreach($_GET['gamme_id'] as $zeGamme) {
                $sql="SELECT produit_id FROM produit_gamme pg";
                $sql.=" WHERE pg.gamme_id = '".$zeGamme."'";
                $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
                $arrProd = $this->sql->record;
                foreach($arrProd as $p) {
                    array_push($searchProduitGamme,$p['produit_id']);
                }
                $searchProduitGamme = array_unique($searchProduitGamme);
            }
            $searchSPEC = true;
        }

        if (!empty($_GET['marque_id'][0])) {
            $searchProduitMarque = array(-1);
            foreach($_GET['marque_id'] as $zeMarque) {
                $sql="SELECT produit_id FROM produit p";
                $sql.=" WHERE p.marque_id = '".$zeMarque."'";
                $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
                $arrProd = $this->sql->record;
                foreach($arrProd as $p) {
                    array_push($searchProduitMarque,$p['produit_id']);
                }
                $searchProduitMarque = array_unique($searchProduitMarque);
            }
            $searchSPEC = true;
        }

        if (!empty($_GET['fournisseur_id'][0])) {
            $searchProduitFrs = array(-1);
            foreach($_GET['fournisseur_id'] as $zeFrs) {
                $sql="SELECT produit_id FROM produit p";
                $sql.=" WHERE p.fournisseur_id = '".$zeFrs."'";
                $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
                $arrProd = $this->sql->record;
                foreach($arrProd as $p) {
                    array_push($searchProduitFrs,$p['produit_id']);
                }
                $searchProduitFrs = array_unique($searchProduitFrs);
            }
            $searchSPEC = true;
        }

        $joinProduit = false;

        $subSql = '';

        $aliasTableCommande = 'c';
        $aliasTableCommandeProduit = 'cp';
        // si jointure produit, on crée une table temp à partir d 'une requete SQL
        $itemJoinProduit = array(
            'marge_ht',
            'marge_ttc',
            'nb_produit',
            'nb_promos',
        );

        $executeJoinProduit = array_intersect($itemJoinProduit, $_GET['item']);

        if (!empty($executeJoinProduit)) {
            $joinProduit = true;
            $aliasTableCommande = 'x';
            $aliasTableCommandeProduit = 'x';
        }

        //-- RECHERCHE

        if (!isset($_GET['date'][0]))
            $_GET['date'][0] = date('d/m/Y', time() - 30 * 24 * 3600);
        if (!isset($_GET['date'][1]))
            $_GET['date'][1] = date('d/m/Y');
        if (!isset($_GET['group']))
            $_GET['group'] = "day";
        if (!isset($_GET['item']))
            $_GET['item'] = array("ca_ht");
        if (!isset($_GET['select_date']))
            $_GET['select_date'] = "cmd";

        switch ($_GET['select_date']) {

            case 'fact':
                $tri_date = 'commande_facture_date';
                break;

            default:
                $tri_date = 'commande_date_ajout';
                break;
        }

        if (!empty($_GET['date'][0])) {
            list($d, $m, $y) = explode("/", $_GET['date'][0]);
            $_GET['date_debut'] = $y . "-" . $m . "-" . $d;
        }
        if (!empty($_GET['date'][1])) {
            list($d, $m, $y) = explode("/", $_GET['date'][1]);
            $_GET['date_fin'] = $y . "-" . $m . "-" . $d;
        }

        $sql = "SELECT ";
        $subSql = "SELECT c." . $tri_date;

        switch ($_GET['group']) {

            case 'week':
                $group = 'YEARWEEK(' . $aliasTableCommande . "."  . $tri_date . ',1) as group_date, CONCAT("Semaine " ,WEEK(' . $aliasTableCommande . "." . $tri_date . ',1)," - ",YEAR(' . $aliasTableCommande . "." . $tri_date . ')) as libelle';
                break;

            case 'month':
                $group = 'CONCAT(YEAR(' . $aliasTableCommande . "." . $tri_date . '),MONTH(' . $aliasTableCommande . "." . $tri_date . ')) as group_date, DATE_FORMAT(' . $aliasTableCommande . "." . $tri_date . ',"%m-%Y") as libelle';
                break;

            case 'quarter':
                $group = 'CONCAT(YEAR(' . $aliasTableCommande . "." . $tri_date . '),QUARTER(' . $aliasTableCommande . "." . $tri_date . ')) as group_date, CONCAT("Trimestre ",QUARTER(' . $aliasTableCommande . "." . $tri_date . ')," - ",YEAR(' . $aliasTableCommande . "." . $tri_date . ')) as libelle';
                break;

            case 'year':
                $group = 'YEAR(' . $aliasTableCommande . "." . $tri_date . ') as group_date, DATE_FORMAT(' . $aliasTableCommande . "." . $tri_date . ',"%Y") as libelle';
                break;

            case 'produit':
                $group = " ".$aliasTableCommandeProduit.".produit_id as group_date, ".$aliasTableCommandeProduit.".produit_nom as libelle";
                $subSql.= ", cp.produit_id, cp.produit_nom";
                break;
            case 'produit_attribut':
                if($joinProduit) {
                    $group = $aliasTableCommande . ".group_date, ".$aliasTableCommande.".libelle";
                    $subSql.= ", IF(cpa.produit_attribut_id,CONCAT(p.produit_id,'-',cpa.produit_attribut_id),p.produit_id) as group_date, IF(cpa.produit_attribut_id,CONCAT(produit_nom,' ',produit_option_nom,' ',produit_option_valeur_nom),produit_nom) as libelle";
                } else {
                    $group = "  IF(cpa.produit_attribut_id,CONCAT(p.produit_id,'-',cpa.produit_attribut_id),p.produit_id) as group_date, IF(cpa.produit_attribut_id,CONCAT(produit_nom,' ',produit_option_nom,' ',produit_option_valeur_nom),produit_nom) as libelle";
                }
                break;

            default:
                $group = 'DATE(' . $aliasTableCommande . "." . $tri_date . ') as group_date, DATE_FORMAT(' . $aliasTableCommande . "." . $tri_date . ',"%d-%m-%Y") as libelle';
                break;
        }

        $sql.= $group;


        $i = 1;
        $nbitem = count($_GET["item"]);
        foreach ($_GET['item'] as $item) {

            switch ($item) {
                case 'ca_ht':
                    $this->itemGraph[$i]['title'] = "Chiffre d affaire HT";
                    $this->itemGraph[$i]['type'] = "euro";
                    if($_GET['group']=='produit' || $_GET['group']=='produit_attribut' || $searchSPEC==true) {
                        if($joinProduit) {
                            $sql .= ", ROUND(SUM(".$aliasTableCommande.".ca_produit_ht),2) as result" . $i;
                            $subSql .= ", SUM(IF(cpa.commande_produit_attribut_id,cpa.produit_option_valeur_total_ht+cp.produit_total_ht,cp.produit_total_ht)) as ca_produit_ht";
                        } else {
                            $sql .= ", ROUND(SUM(IF(cpa.commande_produit_attribut_id,cpa.produit_option_valeur_total_ht+cp.produit_total_ht,cp.produit_total_ht)),2) as result" . $i;
                        }
                    }elseif($joinProduit) {
                        $sql .= ", ROUND(SUM(".$aliasTableCommande . "."."commande_total_ht),2) as result" . $i;
                        $subSql.= ', c.commande_total_ht AS commande_total_ht';
                    } else {
                        $sql .= ", ROUND(SUM(c.commande_total_ht),2) as result" . $i;
                    }
                    break;

                case 'ca_ttc':
                    $this->itemGraph[$i]['title'] = "Chiffre d affaire TTC";
                    $this->itemGraph[$i]['type'] = "euro";
                    if($_GET['group']=='produit' || $_GET['group']=='produit_attribut' || $searchSPEC==true) {
                        if($joinProduit) {
                            $sql .= ", ROUND(SUM(".$aliasTableCommande.".ca_produit_ttc),2) as result" . $i;
                            $subSql .= ", SUM(IF(cpa.commande_produit_attribut_id,cpa.produit_option_valeur_total_ttc+cp.produit_total_ttc,cp.produit_total_ttc)) as ca_produit_ttc";
                        } else {
                            $sql .= ", ROUND(SUM(IF(cpa.commande_produit_attribut_id,cpa.produit_option_valeur_total_ttc+cp.produit_total_ttc,cp.produit_total_ttc)),2) as result" . $i;
                        }
                    }elseif($joinProduit) {
                        $sql .= ", ROUND(SUM(".$aliasTableCommande . "."."commande_total_ttc),2) as result" . $i;
                        $subSql.= ', c.commande_total_ttc AS commande_total_ttc';
                    } else {
                        $sql .= ", ROUND(SUM(c.commande_total_ttc),2) as result" . $i;
                    }
                    break;

                case 'sca_ht':
                    $this->itemGraph[$i]['title'] = "Chiffre d affaire HT (Hors frais de port)";
                    $this->itemGraph[$i]['type'] = "euro";
                    if($joinProduit) {
                        $sql .= ", ROUND(SUM(" . $aliasTableCommande . ".commande_stotal_ht),2) as result" . $i;
                        $subSql.= ", SUM(IF(cpa.commande_produit_attribut_id,cpa.produit_option_valeur_total_ht+cp.produit_total_ht,cp.produit_total_ht)) as commande_stotal_ht";
                    }elseif($_GET['group']=='produit' || $_GET['group']=='produit_attribut' || $searchSPEC==true) {
                        $sql .= ", ROUND(SUM(IF(cpa.commande_produit_attribut_id,cpa.produit_option_valeur_total_ht+cp.produit_total_ht,cp.produit_total_ht)),2) as result" . $i;
                    } else {
                        $sql .= ", ROUND(SUM(c.commande_stotal_ht),2) as result" . $i;
                    }
                    break;

                case 'sca_ttc':
                    $this->itemGraph[$i]['title'] = "Chiffre d affaire TTC (Hors frais de port)";
                    $this->itemGraph[$i]['type'] = "euro";
                    if($joinProduit) {
                        $sql .= ", ROUND(SUM(" . $aliasTableCommande . ".commande_stotal_ttc),2) as result" . $i;
                        $subSql.= ", SUM(IF(cpa.commande_produit_attribut_id,cpa.produit_option_valeur_total_ttc+cp.produit_total_ttc,cp.produit_total_ttc)) as commande_stotal_ttc";
                    }elseif($_GET['group']=='produit' || $_GET['group']=='produit_attribut' || $searchSPEC==true) {
                        $sql .= ", ROUND(SUM(IF(cpa.commande_produit_attribut_id,cpa.produit_option_valeur_total_ttc+cp.produit_total_ttc,cp.produit_total_ttc)),2) as result" . $i;
                    } else {
                        $sql .= ", ROUND(SUM(c.commande_stotal_ttc),2) as result" . $i;
                    }
                    break;

                case 'fdp_ht':
                    $this->itemGraph[$i]['title'] = "Frais de port HT";
                    $this->itemGraph[$i]['type'] = "euro";
                    if($joinProduit) {
                        $sql .= ", ROUND(SUM(".$aliasTableCommande . "."."commande_port_ht),2) as result" . $i;
                        $subSql.= ', c.commande_port_ht AS commande_port_ht';
                    } elseif($_GET['group']=='produit') {
                        $sql .= ", 0 as result" . $i;
                    } elseif($_GET['group']=='produit_attribut') {
                        $sql .= ", 0 as result" . $i;
                    } elseif($searchSPEC==true) {
                        $sql .= ", 0 as result" . $i;
                    } else {
                        $sql .= ", ROUND(SUM(c.commande_port_ht),2) as result" . $i;
                    }

                    break;

                case 'fdp_ttc':
                    $this->itemGraph[$i]['title'] = "Frais de port TTC";
                    $this->itemGraph[$i]['type'] = "euro";
                    if($joinProduit) {
                        $sql .= ", ROUND(SUM(".$aliasTableCommande . "."."commande_port_ttc),2) as result" . $i;
                        $subSql.= ', c.commande_port_ttc AS commande_port_ttc';
                    } elseif($_GET['group']=='produit') {
                        $sql .= ", 0 as result" . $i;
                    } elseif($_GET['group']=='produit_attribut') {
                        $sql .= ", 0 as result" . $i;
                    } elseif($searchSPEC==true) {
                        $sql .= ", 0 as result" . $i;
                    } else {
                        $sql .= ", ROUND(SUM(c.commande_port_ttc),2) as result" . $i;
                    }
                    break;

                case 'marge_ttc':
                    $this->itemGraph[$i]['title'] = "Marge TTC";
                    $this->itemGraph[$i]['type'] = "euro";
                    if($joinProduit) {
                        $sql .= ", ROUND(coalesce(sum(".$aliasTableCommande . "."."marge_ttc), 0),2) as result" . $i;
                        $subSql.= ", SUM(IF(cpa.commande_produit_attribut_id,(cp.produit_prix+cpa.produit_option_valeur_prix-cp.produit_achat-cpa.produit_option_valeur_achat)*(1 + cp.produit_taxe)*cpa.produit_option_valeur_quantite,(cp.produit_prix-cp.produit_achat)*(1 + cp.produit_taxe)*cp.produit_quantite)) as marge_ttc";
                    } else {
                        $sql .= ", ROUND(SUM(IF(cpa.commande_produit_attribut_id,(cp.produit_prix+cpa.produit_option_valeur_prix-cp.produit_achat-cpa.produit_option_valeur_achat)*(1 + cp.produit_taxe)*cpa.produit_option_valeur_quantite,(cp.produit_prix-cp.produit_achat)*(1 + cp.produit_taxe)*cp.produit_quantite)),2) as result" . $i;
                    }
                    break;

                case 'marge_ht':
                    $this->itemGraph[$i]['title'] = "Marge HT";
                    $this->itemGraph[$i]['type'] = "euro";
                    if($joinProduit) {
                        $sql .= ", ROUND(coalesce(sum(".$aliasTableCommande . "."."marge_ht), 0),2) as result" . $i;
                        $subSql.= ", SUM(IF(cpa.commande_produit_attribut_id,(cp.produit_prix+cpa.produit_option_valeur_prix-cp.produit_achat-cpa.produit_option_valeur_achat)*cpa.produit_option_valeur_quantite,(cp.produit_prix-cp.produit_achat)*cp.produit_quantite)) as marge_ht";
                    } else {
                        $sql .= ", ROUND(SUM(IF(cpa.commande_produit_attribut_id,(cp.produit_prix+cpa.produit_option_valeur_prix-cp.produit_achat-cpa.produit_option_valeur_achat)*cpa.produit_option_valeur_quantite,(cp.produit_prix-cp.produit_achat)*cp.produit_quantite)),2) as result" . $i;
                    }
                    break;


                case 'nb_commande':
                    $this->itemGraph[$i]['title'] = "Nb commandes";
                    $this->itemGraph[$i]['type'] = "nb";
                    if($joinProduit) {
                        $sql .= ", COUNT(DISTINCT ".$aliasTableCommande.".commande_id) as result" . $i;
                        $subSql.= ", c.commande_id as commande_id";
                    } else {
                        $sql .= ", COUNT(DISTINCT c.commande_id) as result" . $i;
                    }
                    break;

                case 'nb_produit':
                    $this->itemGraph[$i]['title'] = "Nb de produits commandés";
                    $this->itemGraph[$i]['type'] = "nb";
                    if($joinProduit) {
                        $sql .= ", coalesce(sum(".$aliasTableCommande . "."."nb_produit), 0) as result" . $i;
                        $subSql.= ", SUM(IF(cp.produit_prix < 0, 0, cp.produit_quantite)) as nb_produit";
                    } else {
                        $sql .= ", SUM(IF(cp.produit_prix < 0, 0, cp.produit_quantite)) as result" . $i;
                    }
                    break;

                case 'nb_promos':
                    $this->itemGraph[$i]['title'] = "Nb de promotions utilisées";
                    $this->itemGraph[$i]['type'] = "nb";
                    if($joinProduit) {
                        $sql .= ", coalesce(sum(".$aliasTableCommande . "."."nb_promos), 0) as result" . $i;
                        $subSql.= ", SUM(IF(cp.produit_prix > 0, 0, cp.produit_quantite)) as nb_promos";
                    } else {
                        $sql .= ", SUM(IF(cp.produit_prix > 0, 0, cp.produit_quantite)) as result" . $i;
                    }
                    break;

                case 'promo_ht':
                    $this->itemGraph[$i]['title'] = "Cout des promotions HT";
                    $this->itemGraph[$i]['type'] = "euro";
                    if($joinProduit) {
                        $sql .= ", ROUND(SUM(".$aliasTableCommande.".promo_ht), 2) as result" . $i;
                        $subSql .= ", SUM(IF(cp.produit_prix > 0, 0, cp.produit_total_ht*-1)) as promo_ht";
                    } else {
                        $sql .= ", ROUND(SUM(IF(cp.produit_prix>0,0,cp.produit_total_ht*-1)),2) as result" . $i;
                    }
                    break;

                case 'promo_ttc':
                    $this->itemGraph[$i]['title'] = "Cout des promotions TTC";
                    $this->itemGraph[$i]['type'] = "euro";
                    if($joinProduit) {
                        $sql .= ", ROUND(SUM(".$aliasTableCommande.".promo_ttc), 2) as result" . $i;
                        $subSql .= ", SUM(IF(cp.produit_prix > 0, 0, cp.produit_total_ttc*-1)) as promo_ttc";
                    } else {
                        $sql .= ", ROUND(SUM(IF(cp.produit_prix>0,0,cp.produit_total_ttc*-1)),2) as result" . $i;
                    }
                    break;
            }
            $i++;
        }


        $sql.=", " . $tri_date . " as indice";

        // JOINTURE POUR LES FILTRES --
        $date = explode('/', $date_debut);
        $date_debut = $date[2] . "-" . $date[1] . "-" . $date[0];

        $date = explode('/', $date_fin);
        $date_fin = $date[2] . "-" . $date[1] . "-" . $date[0];

        if ($joinProduit) {
            $sql .= " FROM (".$subSql;
            $sql .= " FROM commande c";
            $sql .= " LEFT JOIN (commande_produit cp) ON (c.commande_id=cp.commande_id)";
            $sql .= " LEFT JOIN (commande_produit_attribut cpa) ON (cp.commande_produit_id=cpa.commande_produit_id)";
        } else {
            $sql .= " FROM commande c";

            // BEN
            if (isset($_GET["item"]) && (in_array('marge_ttc', $_GET["item"]) || in_array('ca_ht_5_5', $_GET["item"]) || in_array('ca_ht_20', $_GET["item"]) || in_array('marge_ht', $_GET["item"]) || in_array('nb_produit', $_GET["item"])) || $_GET['group'] == 'produit' || $_GET['group'] == 'produit_attribut' || !empty($_GET['gamme_id'][0]) || !empty($_GET['categorie_id'][0]) || !empty($_GET['marque_id'][0]) || !empty($_GET['fournisseur_id'][0]) || (isset($_GET["echantillon_id"]) && (in_array('0', $_GET["echantillon_id"]))) || (isset($_GET["echantillon_id"]) && (in_array('1', $_GET["echantillon_id"])))) {
                $sql .= " LEFT JOIN (commande_produit cp) ON (c.commande_id=cp.commande_id)";
                $sql .= " LEFT JOIN (commande_produit_attribut cpa) ON (cp.commande_produit_id=cpa.commande_produit_id)";
            }
        }

        if ($_GET['group'] == 'produit_attribut' || $_GET['group'] == 'produit') {
            $sql .= " LEFT JOIN (produit p) ON (p.produit_id=cp.produit_id)";
        }

        $where = " WHERE commande_statut_id != 99 ";
        if ($_GET['group'] == 'produit' || $_GET['group'] == 'produit_attribut') {
            $where.=" AND p.produit_id IS NOT NULL ";
        }
        $where .= " AND DATE(" . $tri_date . ") >= '" . $date_debut . "' ";
        $where .= " AND DATE(" . $tri_date . ") <= '" . $date_fin . "' ";

        // -- TRAITEMENT DES FILTRE
        // Gestion du produit Ref
        if (!empty($_GET['produit_ref'])) {
            $where .= " AND cp.produit_ref = '" . $_GET['produit_ref'] . "' ";
        }

        // Gestion du produit Ref
        if (!empty($_GET['produit_ref_frs'])) {
            $where .= " AND cp.produit_ref_frs = '" . $_GET['produit_ref_frs'] . "' ";
        }

        if(!empty($searchProduit) && count($searchProduit)>0) {
            $where .= " AND cp.produit_id IN (".implode(",",$searchProduit).")";
        }

        if(!empty($searchProduitGamme) && count($searchProduitGamme)>0) {
            $where .= " AND cp.produit_id IN (".implode(",",$searchProduitGamme).")";
        }
        if(!empty($searchProduitMarque) && count($searchProduitMarque)>0) {
            $where .= " AND cp.produit_id IN (".implode(",",$searchProduitMarque).")";
        }
        if(!empty($searchProduitFrs) && count($searchProduitFrs)>0) {
            $where .= " AND cp.produit_id IN (".implode(",",$searchProduitFrs).")";
        }

        if (!empty($_GET['paiement_id'])) {
            $where .= " AND ( 1 = 2 ";
            foreach ($_GET['paiement_id'] as $paiement) {
                $where .= " OR c.paiement_id = " . $paiement . " ";
            }

            $where .= ") ";
        }
        if (!empty($_GET['pays_id'])) {

            $where .= " AND ( 1 = 2 ";
            foreach ($_GET['pays_id'] as $pays) {
                $where .= " OR c.livraison_pays_id = " . $pays . " ";
            }

            $where .= ") ";
        }
        // TRAITEMENT DES FILTRE --

        $sql.= $where;

        if ($joinProduit) {
            if ($_GET['group'] == 'produit') {
                $groupSubSQL = 'cp.produit_id';
            } elseif($_GET['group'] == 'produit_attribut') {
                $groupSubSQL = 'cpa.produit_attribut_id';
            } else {
                $groupSubSQL = 'c.commande_id';
            }
            $sql .=" GROUP BY ".$groupSubSQL.") " . $aliasTableCommande;
        }


        $sql .= " GROUP BY group_date";

        if ($_GET["group"] == 'produit' || $_GET["group"] == 'produit_attribut') { //Pour gérer les problème de offset
            $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $arr = $this->sql->record;
            $arrData = Array();
            foreach ($arr as $value) {
                if(strpos($value['group_date'],'-')) {
                    //list($ProdAtt,$surmesure) = explode('s',$value['group_date']);
                    list($zeProdId,$zeAttId) = explode('-',$value['group_date']);
                    $sqlN="SELECT CONCAT('#',pn.produit_id,'-',pa.produit_attribut_id,' - ',produit_nom_nom, ' - ',IF(pon1.produit_option_valeur_nom,pon1.produit_option_valeur_nom,''),' ',IF(pon2.produit_option_valeur_nom,pon2.produit_option_valeur_nom,'')) as nom";
                    $sqlN.=" FROM produit_nom pn";
                    $sqlN.=" LEFT JOIN produit_attribut pa ON ( pn.produit_id = pa.produit_id AND pa.produit_attribut_id = '".$zeAttId."')";
                    $sqlN.=" LEFT JOIN produit_option_valeur_nom pon1 ON (pon1.produit_option_valeur_id = pa.produit_option_valeur_id AND pon1.langue_id = 1)";
                    $sqlN.=" LEFT JOIN produit_option_valeur_nom pon2 ON (pon2.produit_option_valeur_id = pa.produit_option_valeur_id_bis AND pon2.langue_id = 1)";
                    $sqlN.=" WHERE pn.langue_id = 1 AND pn.produit_id = '".$zeProdId."'";
                    $this->sql->query($sqlN, SQL_INIT, SQL_ASSOC);
                    $value['libelle'] = $this->sql->record['nom'];
                }
                else {
                    //list($zeProdId,$surmesure) = explode('s',$value['group_date']);
                    $zeProdId = $value['group_date'];
                    $sqlN="SELECT CONCAT('#',produit_id,' - ',produit_nom_nom) as nom";
                    $sqlN.=" FROM produit_nom";
                    $sqlN.="  WHERE langue_id = 1 AND produit_id = '".$zeProdId."'";
                    $this->sql->query($sqlN, SQL_INIT, SQL_ASSOC);
                    $value['libelle'] = $this->sql->record['nom'];
                }
                /*if($surmesure==1) {
                    $value['libelle'] .= " Sur Mesure";
                }*/
                $arrData[strip_tags($value['libelle'])][0] = $value['group_date'];
                for ($j = 1; $j < $i; $j++) {
                    $nom = 'result' . $j;
                    if ($value[$nom] != '0')
                        $arrData[strip_tags($value['libelle'])][$j] = $value[$nom];
                }
            }

            $sql = "";
            foreach ($arrData as $key => $data) {
                if (!empty($sql))
                    $sql.=" UNION ";
                $key = str_replace("'","",$key);
                $key = str_replace("\"","",$key);
                $sql.="(SELECT '" . $data[0] . "' as group_date, '" . addslashes($key) . "' as libelle";
                for ($j = 1; $j < $i; $j++) {
                    if (empty($data[$j]))
                        $sql.=", '0' as result" . $j;
                    else
                        $sql.=", '" . addslashes($data[$j]) . "' as result" . $j;
                }
                $sql.=")";
            }
        }
        $this->request = $sql;
        //echo $sql.'<br/><br/>';
        $title_csv = Array();

        // LABELS
        $label = new BackLabel("DATE");
        $label->setVar('order', false);
        $this->addLabel($label);
        $title_csv[] = "DATE";

        for ($k = 1; $k < $i; $k++) {
            $label = new BackLabel($this->itemGraph[$k]['title']);
            $label->setVar('order', false);
            $this->addLabel($label);
            $title_csv[] = $this->itemGraph[$k]['title'];
        }
        //-- LABELS


        $this->formvars = $_GET;
        $this->dataGraph = $this->getData();

        $_SESSION['title_csv'] = $title_csv;
        $_SESSION['sql_csv'] = $sql;


//        $xml = $this->getXML();


        // RECHERCHE --
        // -- Formulaire
        // Tableau de bord --

        list($xAxis, $yAxis, $series) = $this->getHighChartsSeries();

        $out.="<div class='col-md-8'>";
        $out.="<div class='box box-solid box-primary'>";
        $out.='<div class="box-header with-border">
                <h3 class="box-title">Graphique</h3>
                <div class="box-tools pull-right">
                    <button type="button" data-toggle="tooltip" title="Export au format CSV" onclick="location.href = \'/back/html/tableau_bord/export/csv/\'" class="btn btn-box-tool"><i class="fa fa-file-excel-o"></i></button>                
                </div>
                </div>
            ';
        $out.='<div class="box-body"></div>';
        $out.='<div id="highcharts-container"></div>';
        $out.="</div>"; // end .box-body
        $out.="</div>"; // end .box
        $out.="</div>";

        if(!empty($series)) {
            $out.="<script>
                    jQuery('document').ready(function () { 
                    var myChart = Highcharts.chart('highcharts-container', {
                        chart: {
                            type: 'area'
                        },
                    title: {
                        text: ''
                    },
                    xAxis: {
                        categories:" . json_encode($xAxis) . ",
                        title: {
                            text: ''
                        }
                    },
                    yAxis: {
                        categories:" . json_encode($yAxis) . ",
                        title: {
                            text: ''
                        }
                    },
                    legend: {
                        layout: 'horizontal',
                        align: 'center',
                        verticalAlign: 'bottom'
                    },
                    tooltip : {
                        'shared' : true,
                        'crosshairs' : true,
                    },
                    series: " . json_encode($series) . "
                    });
                });</script>";
        }
        if(empty($series)){
//            TODO centrer
            $out .= '<div id="flashcontent">
					<strong>Pas de données à afficher pour ces paramètres</strong>
				</div>';
        }

        // -- Tableau de bord
        // -- Contenue de droite

        $out .= "</div>";

        $out.= "<script>";
        $out.= "jQuery(document).ready(function(){jQuery('.select2').select2();});";
        $out.= "</script>";

        // -- Contenue

        return $out;
    }

    function getXML() {

        $nbCol = count($this->dataGraph[0]) - 2;
        if ($nbCol > 1) {
            $alpha = 0;
        } else {
            $alpha = 30;
        }
        $series = "";
        for ($i = 0; $i < count($this->dataGraph); $i++) {
            $series.="<value xid='" . $i . "'>" . $this->dataGraph[$i][1] . "</value>";
            for ($k = 1; $k <= $nbCol; $k++) {
                if (!isset($graphs[$k]))
                    $graphs[$k] = "";
                $graphs[$k].="<value xid='" . $i . "'>" . $this->dataGraph[$i][$k + 1] . "</value>";
            }
        }
        $out = "<chart>";
        $out.="<series>";
        $out.=$series;
        $out.="</series>";
        $out.="<graphs>";

        for ($k = 1; $k <= $nbCol; $k++) {
            $out.="<graph gid='" . $k . "' fill_alpha='" . $alpha . "' title='" . $this->itemGraph[$k]['title'] . "'>";
            $out.=$graphs[$k];
            $out.="</graph>";
        }
        $out.="</graphs>";
        $out.="</chart>";

        return $out;
    }

    /**
     * @return array
     */
    function getHighChartsSeries()
    {
        $xAxis = array();
        $yAxis = array();
        $series = array();

        if (count($this->dataGraph) > 0) {
            $nbSeries = count($this->dataGraph[0]) - 2;

            for ($i = 0; $i < $nbSeries; $i++) {
                $series[] = array('name' => $this->itemGraph[$i + 1]['title'], 'data' => array());
            }

            for ($i = 0; $i < count($this->dataGraph); $i++) {
                for ($j = 1; $j <= $nbSeries; $j++) {
                    if ($j == 1) {
                        $xAxis[] = $this->dataGraph[$i][1];
                        $yAxis[] = $this->dataGraph[$i][0];
                    }
                    $series[$j - 1]['data'][] = array($this->dataGraph[$i][1], (float)$this->dataGraph[$i][$j + 1]);
                }
            }
        }
        return array($xAxis, $yAxis, $series);
    }

    function getData() {

        $arrOut = array();
        if (!empty($this->request)) {
            $this->sql->query($this->request, SQL_ALL, SQL_ASSOC);
            $arrData = $this->sql->record;
        }
        else
            $arrData=array();

        $nbCol = count($this->labels) - 1;
        for ($i = 0; $i < count($arrData); $i++) {
            for ($j = 1; $j <= $nbCol; $j++) {
                $value[$arrData[$i]['libelle']][$j] = $arrData[$i]['result' . $j];
            }
        }

        $i = 0;

        if (empty($this->formvars['date_debut']))
            $this->formvars['date_debut'] = $arrData[0]['indice'];
        if (empty($this->formvars['date_fin']))
            $this->formvars['date_fin'] = $arrData[count($arrData) - 1]['indice'];

        //echo $arrData[count($arrData)-2]['commande_date_ajout'];
        switch ($this->formvars['group']) {
            case "day":
                $first = $this->formvars['date_debut'];
                $last = $this->formvars['date_fin'];
                while ($first <= $last) {
                    list($y, $m, $d) = explode("-", $first);
                    $first = date('Y-m-d', mktime(0, 0, 0, $m, $d + 1, $y));
                    $libelle = date('d-m-Y', mktime(0, 0, 0, $m, $d, $y));

                    $arrOut[$i][0] = 0;
                    $arrOut[$i][1] = $libelle;
                    if (isset($value[$libelle]) && count($value[$libelle]) > 0) {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = $value[$libelle][$k];
                        }
                    } else {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = 0;
                        }
                    }
                    $i++;
                }
                break;
            case "week":
                list($y, $m, $d) = explode("-", $this->formvars['date_debut']);
                $first = date("YW", mktime(0, 0, 0, $m, $d, $y));
                list($y, $m, $d) = explode("-", $this->formvars['date_fin']);
                $last = date("YW", mktime(0, 0, 0, $m, $d, $y));
                while ($first <= $last) {
                    $y = substr($first, 0, 4);
                    $w = substr($first, 4, 2);
                    if ($w < 10)
                        $w = substr($w, 1, 1);
                    $libelle = "Semaine " . $w . " - " . $y;
                    $w++;
                    if ($w > 52) {
                        $w = 1;
                        $y++;
                    }
                    if ($w < 10)
                        $w = "0" . $w;
                    $first = $y . $w;

                    $arrOut[$i][0] = 0;
                    $arrOut[$i][1] = $libelle;
                    if (isset($value[$libelle]) && count($value[$libelle]) > 0) {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = $value[$libelle][$k];
                        }
                    } else {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = 0;
                        }
                    }

                    $i++;
                }
                break;
            case "month":
                list($y, $m, $d) = explode("-", $this->formvars['date_debut']);
                $first = date("Ym", mktime(0, 0, 0, $m, $d, $y));
                list($y, $m, $d) = explode("-", $this->formvars['date_fin']);
                $last = date("Ym", mktime(0, 0, 0, $m, $d, $y));
                while ($first <= $last) {
                    $y = substr($first, 0, 4);
                    $m = substr($first, 4, 2);
                    if ($m < 10)
                        $w = substr($m, 1, 1);
                    $libelle = $m . "-" . $y;
                    $m++;
                    if ($m > 12) {
                        $m = 1;
                        $y++;
                    }
                    if ($m < 10)
                        $m = "0" . $m;
                    $first = $y . $m;

                    $arrOut[$i][0] = 0;
                    $arrOut[$i][1] = $libelle;
                    if (isset($value[$libelle]) && count($value[$libelle]) > 0) {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = $value[$libelle][$k];
                        }
                    } else {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = 0;
                        }
                    }

                    $i++;
                }
                break;
            case "quarter":
                list($y, $m, $d) = explode("-", $this->formvars['date_debut']);
                if ($m >= 1 || $m <= 3)
                    $q = "1";
                if ($m >= 4 || $m <= 6)
                    $q = "2";
                if ($m >= 7 || $m <= 9)
                    $q = "3";
                if ($m >= 10 || $m <= 12)
                    $q = "4";
                $first = $y . $q;
                list($y, $m, $d) = explode("-", $this->formvars['date_fin']);
                if ($m >= 1 || $m <= 3)
                    $q = "1";
                if ($m >= 4 || $m <= 6)
                    $q = "2";
                if ($m >= 7 || $m <= 9)
                    $q = "3";
                if ($m >= 10 || $m <= 12)
                    $q = "4";
                $last = $y . $q;
                while ($first <= $last) {
                    $y = substr($first, 0, 4);
                    $q = substr($first, 4, 1);

                    $libelle = "Trimestre " . $q . " - " . $y;
                    $q++;
                    if ($q > 4) {
                        $q = 1;
                        $y++;
                    }
                    $first = $y . $q;

                    $arrOut[$i][0] = 0;
                    $arrOut[$i][1] = $libelle;
                    if (isset($value[$libelle]) && count($value[$libelle]) > 0) {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = $value[$libelle][$k];
                        }
                    } else {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = 0;
                        }
                    }

                    $i++;
                }
                break;
            case "year":
                list($y, $m, $d) = explode("-", $this->formvars['date_debut']);
                $first = $y;
                list($y, $m, $d) = explode("-", $this->formvars['date_fin']);
                $last = $y;
                while ($first <= $last) {
                    $y = $first;
                    $libelle = $y;
                    $y++;
                    $first = $y;

                    $arrOut[$i][0] = 0;
                    $arrOut[$i][1] = $libelle;
                    if (isset($value[$libelle]) && count($value[$libelle]) > 0) {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = $value[$libelle][$k];
                        }
                    } else {
                        for ($k = 1; $k <= $nbCol; $k++) {
                            $arrOut[$i][$k + 1] = 0;
                        }
                    }

                    $i++;
                }

                break;

            case "produit":
            case "produit_attribut":
                foreach ($arrData as $val) {
                    $arrOut[$i][0] = 0;
                    $arrOut[$i][1] = $val['libelle'];
                    for ($k = 1; $k <= $nbCol; $k++) {
                        $arrOut[$i][$k + 1] = $val['result' . $k];
                    }
                    $i++;
                }

                break;
        }

        return $arrOut;
    }

//--
}
