<?php

namespace Annotation;

use Symfony\Component\Routing\Loader\AnnotationClassLoader as AnnotationClassLoaderSF;
use Symfony\Component\Routing\Route;

class AnnotationClassLoader extends  AnnotationClassLoaderSF{

    protected function configureRoute(Route $route, \ReflectionClass $class, \ReflectionMethod $method, $annot)
    {
        /*$classAnnot = $this->reader->getClassAnnotation($class, $this->routeAnnotationClass);
        dump($classAnnot);*/

        $route->setDefault('_controller', $class->getName());
        $route->setDefault('_action', $method->getName());

    }
}