<?php

class ProduitAlerte extends Model
{

    protected $table = "produit_alerte";

    /**
     * @param null $id
     * @throws \Exception
     */
    public function __construct($id = null)
    {
        parent::__construct($id);
    }

    /**
     * @param array $formvars
     *
     * @return array
     */
    public function getOne($formvars = array())
    {
        $result = $this->get($formvars);
        return (!empty($result)) ? $result[0] : array();
    }

    /**
     * @param array $formvars
     *
     * @return array
     *
     * @throws DediException
     */
    public function get($formvars = array())
    {
        $q = new \Query();
        $q->select()
            ->from($this->table);
        if(isset($formvars['client_email'])){
            $q->where('client_email = "'.$formvars['client_email'].'"');
        }
        if(isset($formvars['produit_id'])){
            $q->where('produit_id = '.(int)$formvars['produit_id']);
        }
        if(isset($formvars['produit_attribut_id'])){
            $q->where('produit_attribut_id = '.(int)$formvars['produit_attribut_id']);
        }
        $result = $this->sql->getAll($q->build());
        return $result;
    }

} 