<?php

class bProduit_caracteristique_valeur extends BackModule {

    function Form($formvars = array()) {

        // SQL
        if (!empty($formvars['id'])) {
            $this->request = getTable('produit_caracteristique_valeur', $formvars['id']);
        }
        //-- SQL
        // Champs du formulaire
        $form = new BackForm("Produit ID", "hidden", "produit_id");
        $this->addForm($form);

        $form = new BackForm("Caracteristique", "autocomplete", "caracteristique_valeur_id");
        $form->addAttr('class', 'required');
        $form->addAttr('style', 'width:400px');
        $form->setVar('method', '/caracteristique_valeur/custom/autocomplete/?caracteristique_valeur_nom_nom=');
        $form->setVar('param', 'caracteristique_valeur');
        $this->addForm($form);
        //-- Champs du formulaire

        if (!isset($formvars['id']))
            $formvars['id'] = 0;
        return $this->displayForm($formvars['id'], $formvars['div']);
    }

    function Listing($formvars = array()) {

        // SQL
        $sql = "SELECT pcv.produit_caracteristique_valeur_id";
        $sql.=", cn.caracteristique_nom_nom";
        $sql.=", cvn.caracteristique_valeur_nom_nom";
        $sql.=" FROM (produit_caracteristique_valeur pcv, caracteristique_valeur cv)";
        $sql.=" LEFT JOIN caracteristique_valeur_nom cvn ON(pcv.caracteristique_valeur_id = cvn.caracteristique_valeur_id AND cvn.langue_id = '".LANGUE."')";
        $sql.=" LEFT JOIN caracteristique_nom cn ON(cv.caracteristique_id = cn.caracteristique_id AND cn.langue_id = '".LANGUE."')";
        $sql.=" WHERE pcv.caracteristique_valeur_id=cv.caracteristique_valeur_id";
        if (!empty($formvars['produit']))
            $sql.=" AND pcv.produit_id = '" . $formvars['produit'] . "'";

        $this->request = $sql;
        //-- SQL
        // LABELS
        $label = new BackLabel("NOM");
        $this->addLabel($label);

        $label = new BackLabel("VALEUR");
        $this->addLabel($label);

        //-- LABELS

        return $this->displayList($formvars['type']);
    }

//--
}