<?php

use Phinx\Migration\AbstractMigration;

class InsertCivilite extends AbstractMigration
{
    public function up()
    {
        $civilite = array(
            array('civilite_id' => '1'),
            array('civilite_id' => '2'),
            array('civilite_id' => '3')
        );

        $this
            ->table('civilite')
            ->insert($civilite)
            ->save();

        $civilite_nom = array(
            array('civilite_nom_id' => '1','civilite_id' => '1','langue_id' => '1','civilite_nom_nom' => 'M.'),
            array('civilite_nom_id' => '2','civilite_id' => '2','langue_id' => '1','civilite_nom_nom' => 'Mme'),
            array('civilite_nom_id' => '3','civilite_id' => '3','langue_id' => '1','civilite_nom_nom' => 'Mlle')
        );

        $this
            ->table('civilite_nom')
            ->insert($civilite_nom)
            ->save();
    }

    public function down()
    {
        $this->execute('SET FOREIGN_KEY_CHECKS=0');
        $this
            ->table('civilite')
            ->truncate();
        $this
            ->table('civilite_nom')
            ->truncate();
        $this->execute('SET FOREIGN_KEY_CHECKS=1');
    }
}
